<?php

# Plugin Additional Stats in Index Page 1.0 #
#  Author: Arno (http://www.mybbdestek.com  #
#           All rights reserved             #

if(!defined("IN_MYBB")) {
	die("Direct initialization of this file is not allowed.<br /><br />Please make sure IN_MYBB is defined.");
}


$plugins->add_hook("index_start", "adstats");


function adstats_info()
{
	return array(
		"name"        => "Adstats",
		"title"        => "Additional Stats in Index Page",
		"description" => "Displays .",
		"website"     => "http://www.mybbdestek.com",
		"author"      => "Arno",
		"authorsite"  => "http://www.mybbdestek.com",
		"version"     => "1.0",
		);
}


function adstats_activate()
{

    global $db, $lang;
	
	$adstats_group = array(
		"gid" => "NULL",
		"name" => "adstats",
		"title" => "Additional Stats in Index Page",
		"description" => "Display additional stats (new users today, active users today, total attachments, total attachments space used, new posts today, new threads today) .",
		"disporder" => "1",
		"isdefault" => "no",
		);
	$db->insert_query(TABLE_PREFIX."settinggroups", $adstats_group);
	$gid = $db->insert_id();
	
	$set_adstats_newuser = array(
		"sid" => "NULL",
		"name" => "set_adstats_newuser",
		"title" => "New users today",
		"description" => "Display new users today on index page?",
		"optionscode" => "yesno",
		"value" => "yes",
		"disporder" => "1",
		"gid" => intval($gid),
		);
	$db->insert_query(TABLE_PREFIX."settings", $set_adstats_newuser);
	
		$set_adstats_activeuser = array(
		"sid" => "NULL",
		"name" => "set_adstats_activeuser",
		"title" => "Active users today",
		"description" => "Display active users today on index page?",
		"optionscode" => "yesno",
		"value" => "yes",
		"disporder" => "2",
		"gid" => intval($gid),
		);
	$db->insert_query(TABLE_PREFIX."settings", $set_adstats_activeuser);
	
		$set_adstats_nummsg = array(
		"sid" => "NULL",
		"name" => "set_adstats_nummsg",
		"title" => "Posts and threads today",
		"description" => "Display post and threads today on index page?",
		"optionscode" => "yesno",
		"value" => "yes",
		"disporder" => "3",
		"gid" => intval($gid),
		);
	$db->insert_query(TABLE_PREFIX."settings", $set_adstats_nummsg);
	
		$set_adstats_attach = array(
		"sid" => "NULL",
		"name" => "set_adstats_attach",
		"title" => "Total Attachments",
		"description" => "Display total attachments and space used on index page?",
		"optionscode" => "yesno",
		"value" => "yes",
		"disporder" => "4",
		"gid" => intval($gid),
		);
	$db->insert_query(TABLE_PREFIX."settings", $set_adstats_attach);
	
	
	
	require MYBB_ROOT."inc/adminfunctions_templates.php";
	find_replace_templatesets("index_stats", '#{\$lang->stats_mostonline}#', "{\$lang->stats_mostonline}\n {\$newuser}\n {\$activeuser}\n {\$nummsg}\n {\$attach}\n");

	
		$templatearray = array(
		"tid" => "NULL",
		"title" => "adstats_newuser",
		"template" => "<br />New users today: {\$newusers[newusers]}",
		"sid" => "-1",
		);
	$db->insert_query(TABLE_PREFIX."templates", $templatearray);

		$templatearray = array(
		"tid" => "NULL",
		"title" => "adstats_activeuser",
		"template" => "<br />Active users today: <a href=\"online.php?action=today\">{\$activeusers[activeusers]}</a>",
		"sid" => "-1",
		);
	$db->insert_query(TABLE_PREFIX."templates", $templatearray);
		
		$templatearray = array(
		"tid" => "NULL",
		"title" => "adstats_nummsg",
		"template" => "<br />New threads and posts today: \$newthreads[newthreads] - <a href=\"search.php?action=getdaily\">\$newposts[newposts]</a>",
		"sid" => "-1",
		);
	$db->insert_query(TABLE_PREFIX."templates", $templatearray);
		
		$templatearray = array(
		"tid" => "NULL",
		"title" => "adstats_attach",
		"template" => "<br />Total Attachments and space used: {\$attachs[numattachs]} - {\$attachs[spaceused]}",
		"sid" => "-1",
		);
	$db->insert_query(TABLE_PREFIX."templates", $templatearray);
	
	

}

function adstats_deactivate()
{

    global $db;
	
	$query = $db->query("SELECT gid FROM ".TABLE_PREFIX."settinggroups WHERE name='adstats'");
	$g = $db->fetch_array($query);
	$db->query("DELETE FROM ".TABLE_PREFIX."settinggroups WHERE gid='".$g['gid']."'");
	
	require MYBB_ROOT."inc/adminfunctions_templates.php";
	find_replace_templatesets("index_stats", '#<br />{\$newuser}\n {\$activeuser}\n {\$nummsg}\n {\$attach}(\r?)\n#', "", 0);

	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='adstats_newuser'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='adstats_activeuser'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='adstats_nummsg'");
	$db->query("DELETE FROM ".TABLE_PREFIX."templates WHERE title='adstats_attach'");	
	
}

function adstats()
{

    global $db, $mybb, $cache, $lang, $posts, $threads, $newuser, $activeuser, $templates, $nummsg, $attach, $adstats;
	
	if($mybb->settings['set_adstats_newuser'] == "yes") {

// Get the number of new users for today
    $timecut = time() - 86400;
    $query = $db->simple_select(TABLE_PREFIX."users", "COUNT(*) AS newusers", "regdate>'$timecut'");
    $newusers = $db->fetch_array($query); 
	eval("\$newuser = \"".$templates->get("adstats_newuser")."\";");
	}

	if($mybb->settings['set_adstats_activeuser'] == "yes") {
	// Get the number of active users today
	$query = $db->simple_select(TABLE_PREFIX."users", "COUNT(*) AS activeusers", "lastvisit>'$timecut'");
	$activeusers = $db->fetch_array($query);
	eval("\$activeuser = \"".$templates->get("adstats_activeuser")."\";");
	}
	
	if($mybb->settings['set_adstats_nummsg'] == "yes") {	
	// Get the number of new threads for today
	$query = $db->simple_select(TABLE_PREFIX."threads", "COUNT(*) AS newthreads", "dateline>'$timecut' AND visible='1' AND closed NOT LIKE 'moved|%'");
	$newthreads = $db->fetch_array($query);
	
	// Get the number of new posts for today
	$query = $db->simple_select(TABLE_PREFIX."posts", "COUNT(*) AS newposts", "dateline>'$timecut' AND visible='1'");
	$newposts = $db->fetch_array($query);
	eval("\$nummsg = \"".$templates->get("adstats_nummsg")."\";");
	}
	
	if($mybb->settings['set_adstats_attach'] == "yes") {
	// Get the number and total file size of attachments
	$query = $db->simple_select(TABLE_PREFIX."attachments", "COUNT(*) AS numattachs, SUM(filesize) as spaceused", "visible='1' AND pid>0");
	$attachs = $db->fetch_array($query);
	$attachs['spaceused'] = get_friendly_size($attachs['spaceused']);
	eval("\$attach = \"".$templates->get("adstats_attach")."\";");
	}
	
}

